#!/usr/bin/ruby

# file: recordx-parser.rb

require 'rexleparser'

class RecordxParser

  def initialize(s)
    parse(s){|x| yield(x)}
  end

  def to_a()
    @a
  end
  
  protected
  
  def parse(s)

    s.instance_eval{
      def fetch_node(name)
        self.slice(((self =~ /<#{name}>/) + name.length + 2) .. \
          (self =~ /.(?!.*<\/#{name}>)/m) - 1) if self[/<#{name}>/]
      end
    }

    root_name = s[/<(\w+)/,1]

    summary = RexleParser.new("<summary>#{s.fetch_node(:summary)}</summary>").to_a

    raw_records = s.fetch_node(:records)
    records = nil

    if raw_records then
      node_name = raw_records[/<(\w+)/,1]
      a_records = raw_records.strip.split(/(?=<#{node_name}[^>]*>)/)
      records = fetch_records(a_records)
    end 

    [root_name, "", {}, [*summary], ['records', "",{}, *records]]
  end
  
  private
  
  def fetch_records(a_records)
    a_records.map {|x| yield(x)}
  end
end
